#ifndef DOTLABELCONFIGURATION_H
#define DOTLABELCONFIGURATION_H

#include "Graph/IGraphLabelConfiguration.h"

namespace divine::gui::dot
{
    class DotLabelConfiguration : virtual public graph::IGraphLabelConfiguration
    {
    public:
        DotLabelConfiguration()
        {
            m_labelFont.setPixelSize(14);
        }

        DotLabelConfiguration(const DotLabelConfiguration& other)
        {
            m_label = other.m_label;
            m_labelFont = other.m_labelFont;
            m_labelColor = other.m_labelColor;
            m_horizontalAlignment = other.m_horizontalAlignment;
            m_verticalAlignment = other.m_verticalAlignment;
        }

        virtual const QString& label() const override { return m_label; }
        void setLabel(const QString& label) { m_label = label; }
        const QFont& labelFont() const override { return m_labelFont; }
        void setLabelFont(const QFont& font) { m_labelFont = font; }
        const QColor& labelColor() const override { return m_labelColor; }
        void setLabelColor(const QColor& color) { m_labelColor = color; }

        const Qt::AlignmentFlag& labelHorizontalAlignment() const override { return m_horizontalAlignment; }
        void setLabelHorizontalAlignment(const Qt::AlignmentFlag& alignment) { m_horizontalAlignment = alignment; }
        const Qt::AlignmentFlag& labelVerticalAlignment() const override { return m_verticalAlignment; }
        void setLabelVerticalAlignment(const Qt::AlignmentFlag& alignment) { m_verticalAlignment = alignment; }

    private:
        QString m_label;
        QFont m_labelFont = QFont("Times");
        QColor m_labelColor = QColor(Qt::black);
        Qt::AlignmentFlag m_horizontalAlignment = Qt::AlignHCenter;
        Qt::AlignmentFlag m_verticalAlignment = Qt::AlignVCenter;
    };
}

#endif //DOTLABELCONFIGURATION_H
