#ifndef DOTNODECONFIGURATION_H
#define DOTNODECONFIGURATION_H

#include "Graph/IGraphNodeConfiguration.h"

#include "Dot/DotLabelConfiguration.h"

namespace divine::gui::dot
{
    class DotNodeConfiguration : public DotLabelConfiguration, virtual public graph::IGraphNodeConfiguration
    {
    public:
        DotNodeConfiguration() : DotLabelConfiguration()
        {
            setLabel("\\N");
        }

        DotNodeConfiguration(const DotNodeConfiguration& other) : DotLabelConfiguration(other)
        {
            m_boundingRect = other.m_boundingRect;
            m_backgroundColor = other.m_backgroundColor;
            m_borderColor = other.m_borderColor;
        }

        const QRectF& boundingRect() const override { return m_boundingRect; }
        void setBoundingRect(const QRectF& rect) { m_boundingRect = rect; }

        const QColor& backgroundColor() const override { return m_backgroundColor; }
        void setBackgroundColor(const QColor& color) { if (color.isValid()) m_backgroundColor = color; }
        const QColor& borderColor() const override { return m_borderColor; }
        void setBorderColor(const QColor& color) { if (color.isValid()) m_borderColor = color; }

        const QRectF& labelBoundingRect() const override { return boundingRect(); }
    private:
        QRectF m_boundingRect;

        QColor m_backgroundColor = QColor(Qt::transparent);
        QColor m_borderColor = QColor(Qt::black);
    };
}

#endif // DOTNODECONFIGURATION_H
