#ifndef GRAPHEDGE_H
#define GRAPHEDGE_H

#include <QSGNode>
#include <QSGFlatColorMaterial>

#include "IGraphEdgeConfiguration.h"

namespace divine::gui::graph
{
    class GraphEdge : public QSGNode
    {
    public:
        GraphEdge(const IGraphEdgeConfiguration& config);

    private:
        void handleArrows(const IGraphEdgeConfiguration& config);

        void setColor(const QColor& color);
        void setLineCoordinates(const IGraphEdgeConfiguration& config);

        QVector<QPointF> calculateArrowPoints(const QPointF &pointFrom, const QPointF &pointTo) const;
        void setArrowGeometry(QSGGeometry& geometry, const QPointF& from, const QPointF& to);

        QSGGeometryNode m_lineNode;
        QSGGeometry m_lineGeometry;

        QSGFlatColorMaterial m_material;

        QSGGeometryNode m_headArrowNode;
        QSGGeometry m_headArrowGeometry;

        QSGGeometryNode m_tailArrowNode;
        QSGGeometry m_tailArrowGeometry;
    };
}


#endif // GRAPHEDGE_H
