#ifndef IGRAPHLABELCONFIGURATION_H
#define IGRAPHLABELCONFIGURATION_H

#include <QColor>
#include <QFont>
#include <QRectF>

namespace divine::gui::graph
{
    /*!
     * \brief Defines a text to be displayed on the graph.
     */
    class IGraphLabelConfiguration
    {
    public:
        virtual ~IGraphLabelConfiguration() {}

        virtual const QString& label() const = 0;
        virtual const QRectF& labelBoundingRect() const = 0;

        virtual const QFont& labelFont() const = 0;
        virtual const QColor& labelColor() const = 0;

        virtual const Qt::AlignmentFlag& labelHorizontalAlignment() const = 0;
        virtual const Qt::AlignmentFlag& labelVerticalAlignment() const = 0;
    };
}

#endif //IGRAPHLABELCONFIGURATION_H
