#ifndef IGRAPHNODECONFIGURATION_H
#define IGRAPHNODECONFIGURATION_H

#include "IGraphLabelConfiguration.h"

namespace divine::gui::graph
{
    /*!
     * \brief Defines a node to be displayed in the graph.
     *
     * Node is currently always displayed as an ellipse
     * defined by the boudning rect.
     *
     * Usually each node will have it's label which is defined
     * by the parent interface.
     */
    class IGraphNodeConfiguration : virtual public IGraphLabelConfiguration
    {
    public:
        virtual ~IGraphNodeConfiguration() {}

        virtual const QRectF& boundingRect() const = 0;

        virtual const QColor& backgroundColor() const = 0;
        virtual const QColor& borderColor() const = 0;
    };
}

#endif // IGRAPHNODECONFIGURATION_H
