#ifndef EXECUTIONCONTROLVIEWMODEL_H
#define EXECUTIONCONTROLVIEWMODEL_H

#include <QObject>

#include "Models/SimulatorModel.h"

namespace divine::gui::viewmodels
{
    /*!
     * \brief Extremely simple ViewModel that provides the view
     * with access to Simulator.
     *
     * Since the API for stepping would be exactly the same as
     * it is directly on the SimulatorModel the View can just use it directly.
     */
    class ExecutionControlViewModel : public QObject
    {
        Q_OBJECT
        Q_PROPERTY(models::SimulatorModel* simulator READ simulator WRITE setSimulator)
    public:        
        explicit ExecutionControlViewModel(QObject *parent = nullptr);

        models::SimulatorModel* simulator() const;
        void setSimulator(models::SimulatorModel* simulator);

    public slots:
        void callContinue();

    private:
        models::SimulatorModel* m_simulator;
    };
}

#endif // EXECUTIONCONTROLVIEWMODEL_H
