import QtQuick 2.10
import QtQuick.Controls 1.4

import divine.gui 1.0

Item {
    property alias viewModel: viewModel

    TreeView {
        id: dataTree
        anchors.fill: parent
        frameVisible: false

        model: viewModel

        TableViewColumn {
            id: nameColumn
            title: qsTr('Name')
            role: 'name'
            movable: false
        }
        TableViewColumn {
            id: valueColumn
            title: qsTr('Value')
            role: 'value'
            movable: false
        }
        TableViewColumn {
            id: typeColumn
            title: qsTr('Type')
            role: 'type'
            movable: false
        }
    }

    DataViewModel {
        id: viewModel
        onShownDataChanged: fitToContents()
    }

    // resize the columns and leave a little padding for readability, also see QTBUG-36518
    function fitToContents() {
        dataTree.resizeColumnsToContents();
        nameColumn.resizeToContents();
        valueColumn.resizeToContents();
        nameColumn.width = Math.max(75, nameColumn.width);
        valueColumn.width = Math.max(75, valueColumn.width);
        typeColumn.width = dataTree.width - nameColumn.width - valueColumn.width;
    }
}
