import QtQuick 2.10
import QtQuick.Controls 1.4

import divine.gui 1.0

Item {
    property alias viewModel: viewModel

    TableView {
        id: table

        anchors.fill: parent
        frameVisible: false
        model: viewModel

        onClicked: viewModel.goToFile(row)

        TableViewColumn {
            id: functionColumn
            title: qsTr('Function')
            role: 'functionName'
            movable: false
        }
        TableViewColumn {
            id: lineColumn
            title: qsTr('Line')
            role: 'line'
            movable: false
        }
        TableViewColumn {
            id: nameColumn
            title: qsTr('File')
            role: 'file'
            movable: false
        }
    }

    StackTraceViewModel {
        id: viewModel
        onStackTraceChanged: fitToContents()
    }

    // resize the columns and leave a little padding for readability, also see QTBUG-36518
    function fitToContents() {
        functionColumn.resizeToContents();
        lineColumn.resizeToContents();
        functionColumn.width = Math.max(75, functionColumn.width + 5);
        lineColumn.width = Math.max(75, lineColumn.width + 5);
        nameColumn.width = table.width - functionColumn.width - lineColumn.width;
    }
}
