import QtQuick 2.10
import QtQuick.Controls 2.3
import QtQuick.Layouts 1.3
import QtQuick.Controls 1.4 as Controls1
import QtQuick.Controls.Styles 1.4

import divine.gui 1.0

ColumnLayout
{
    property SettingsModel settings
    property alias viewModel: viewModel

    signal stateGraphRequested()

    spacing: 0

    Controls1.TableView {
        Layout.fillHeight: true
        Layout.fillWidth: true

        frameVisible: false

        model: viewModel.stateCount
        onClicked: viewModel.goToState(row)

        Controls1.TableViewColumn {
            id: lineColumn
            title: qsTr('Name')
            delegate: Text {
                text: viewModel.getStateName(styleData.row)
            }
        }
    }

    Item {
        id: buttonsRow

        Layout.preferredHeight: 35
        Layout.fillWidth: true

        Button {
            height: parent.height

            action: Action {
                text: qsTr('Graph')
                icon.name: 'image-x-generic'
                shortcut: settings.shortcuts.showStateGraph
                onTriggered: stateGraphRequested()
            }
            ShortcutTooltip {}
        }

        Button {
           height: parent.height
           anchors.centerIn: parent

           action: Action {
                text: qsTr('Capture')
                icon.name: 'list-add'
                shortcut: settings.shortcuts.captureState
                onTriggered: viewModel.captureState()
            }
            ShortcutTooltip {}
        }

        Button {
            height: parent.height
            anchors.right: parent.right

            action: Action {
                text: qsTr('Go to last')
                icon.name: 'go-last'
                shortcut: settings.shortcuts.goToLastState
                onTriggered: viewModel.goToLastState()
            }
            ShortcutTooltip {}
        }
    }

    StateViewModel
    {
        id: viewModel
    }
}
